/************************************************/
/*						*/
/*      Copyright:				*/
/*	 Jean-Marc Pigeon <jmp@safe.ca>	 2009	*/
/*						*/
/************************************************/
/* This program is free software; you can 	*/
/* redistribute it and/or modify it under the 	*/
/* terms of the GNU General Public License as	*/
/* published by the Free Software Foundation	*/
/* version 2 of the License			*/
/*						*/
/* This program is distributed in the hope that */
/* it will be useful, but WITHOUT ANY WARRANTY; */
/* without even the implied warranty of		*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR	*/
/* PURPOSE.  See the GNU General Public License	*/
/* for more details.				*/
/*						*/
/* You should have received a copy of the GNU	*/
/* General Public License along with this 	*/
/* program; if not, write to the Free Software	*/
/* Foundation, Inc., 51 Franklin Street,	*/
/* Fifth Floor, Boston, MA  02110-1301, USA.	*/
/************************************************/
/*						*/
/*	UNIDIR:					*/
/*	Take Care of all access to directory	*/
/*						*/
/************************************************/
#include	<unistd.h>
#include	<malloc.h>
#include	<string.h>
#include	<errno.h>
#include	<dirent.h>
#include	<sys/stat.h>
#include	"subrou.h"
#include	"unidir.h"
/*

*/
/************************************************/
/*						*/
/*	Procedure to get a list of  ALL file	*/
/*	within	application specific directory	*/
/*	collect all file with a specific	*/
/*	extension.				*/
/*						*/
/************************************************/
char **dir_getlst(char *subdir,char *ext)

{
#define	OPLS	"unidir.c:dir_getlst,"

char **lst;
DIR *local;
char curdir[500];

lst=(char **)0;
if (getcwd(curdir,sizeof(curdir))==(char *)0)
  (void) core_dump("%s can't hold the current directory path! (bug?)",OPLS);
if (chdir(subdir)<0) {
  (void) alert(0,"%s can't move to dir <%s> (errno=<%s>)",
		 OPLS,subdir,strerror(errno));
  return lst;
  }
if ((local=opendir("."))!=(DIR *)0) {
  struct dirent *cur;

  while ((cur=readdir(local))!=(struct dirent *)0) {
    char *d_name;
    char *look;

    d_name=strdup(cur->d_name);
    if ((look=strstr(d_name,ext))!=(char *)0) {
      if (strcmp(look,ext)==0) {
	*look='\000';
        lst=(char **)rou_addveclst((void **)lst,(void *)strdup(d_name));
        }
      }
    (void) free(d_name);
    }
  (void) closedir(local);
  }
else {
  (void) alert(0,"%s can't read '%s' (errno=<%s>",OPLS,subdir,strerror(errno));
  }
if (chdir(curdir)<0)
  (void) alert(0,"%s Unable to put back directory <%s> (errno=<%s>)",
		 OPLS,curdir,strerror(errno));
return lst;
}
/*

*/
/************************************************/
/*						*/
/*	Procedur to get all directory within a	*/
/*	specific application directory		*/
/*						*/
/************************************************/
char **dir_getdir(char *subdir)

{
#define	OPDI	"unidir.c:dir_getdir,"

char **lst;
DIR *local;
char curdir[500];

lst=(char **)0;
if (getcwd(curdir,sizeof(curdir))==(char *)0)
  (void) core_dump("%s can't hold the current directory path! (bug?)",OPDI);
if (chdir(subdir)<0) {
  (void) alert(0,"%s can't move to '%s' (errno=<%s>",
		  OPDI,subdir,strerror(errno));
  return lst;
  }
if ((local=opendir("."))!=(DIR *)0) {
  struct dirent *cur;

  while ((cur=readdir(local))!=(struct dirent *)0) {
    struct stat bufstat;
    char filename[500];

    if (cur->d_name[0]=='.')
      continue;
    (void) snprintf(filename,sizeof(filename),"%s/%s",subdir,cur->d_name);
    if (stat(filename,&bufstat)==0) {
      if (S_ISREG(bufstat.st_mode)==0)
        lst=(char **)rou_addveclst((void **)lst,(void *)strdup(cur->d_name));
      }
    }
  (void) closedir(local);
  }
else {
  (void) alert(0,"%s can't read '%s' (errno=<%s>",OPDI,subdir,strerror(errno));
  }
if (chdir(curdir)<0)
  (void) alert(0,"%s Unable to put back directory <%s> (errno=<%s>)",
		 OPDI,curdir,strerror(errno));
return lst;
}

